<script lang="ts">
import { getNavigationClient } from '~/plugins/contentful';
import { NAV_CONTENT_TYPES } from '~/common/content-types';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { FOOTER_CTF_ID } from '~/common/constants';

export default {
  name: 'SlpFooterHOC',
  props: {
    contentfulEntryId: {
      type: String,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      footer: {},
    };
  },
  async fetch() {
    if (
      this.$nuxt.context.payload &&
      this.$nuxt.context.payload[this.$i18n.locale]['footer']
    ) {
      // Production build
      const { footer } = this.$nuxt.context.payload[this.$i18n.locale];

      this.footer = footer;
    } else {
      const { items } = await getNavigationClient().getEntries({
        content_type: NAV_CONTENT_TYPES.FOOTER,
        'sys.id': FOOTER_CTF_ID,
        include: 3,
        locale: convertToCaseSensitiveLocale(this.$i18n.locale),
      });

      if (!items.length) {
        const error = `Footer entry with id ${FOOTER_CTF_ID} not found`;
        // eslint-disable-next-line
        console.error(error);
        throw new Error();
      }

      const [footer] = items;

      this.footer = footer;
    }
  },
};
</script>

<template>
  <section>
    <client-only>
      <SlpFooter
        :contentful-footer-data="footer"
        :contentful-entry-url="contentfulEntryId"
      />
    </client-only>
  </section>
</template>
